{% load static %}
{% load i18n %}

{% block content %}

<style>

    .info{
        padding: 6px 8px;
        background: #A9A9A9;
        background: rgba(169, 169, 169, 0.8);
        box-shadow: 0 0 15px rgba(0, 0, 0, 0.2);
        border-radius: 5px;
    }

    .info h4{
        margin: 0 0 5px;
        color: #555;
        opacity: 0.8;
    }
    
    #pagination_box{
        position: absolute;
        top: 85%;
        left: 50%;
        margin-right: -50%;
        transform: translate(-50%, -50%)
    }

    #imageDate{
        margin-left: 20%;
    }

    .layers_sat{
        background-image: url("{% static 'shared/img/favicon.png' %}");
        width: 36px;
        height: 36px;
    }

</style>

    <div id="map">
        <div class="maptools" id="maptools"></div>
        <div id="timecontrol"></div>
        <div id="loadingcontrol"></div>
    </div>

    <!-- Others -->
    <script type="text/javascript" src="{% static 'vendor/iso8601-js-period/iso8601.min.js' %}"></script>

    <!-- Leaflet css -->
    <link type="text/css" rel="stylesheet" href="{% static 'vendor/leaflet/leaflet.css' %}" media="screen">
    <link type="text/css" rel="stylesheet" href="{% static 'vendor/leaflet/leaflet.timedimension.control.min.css' %}" media="screen">
    <link type="text/css" rel="stylesheet" href="{% static 'vendor/leaflet/leaflet.bookmarks.css' %}">
    <link type="text/css" rel="stylesheet" href="{% static 'vendor/leaflet/Control.Loading.css' %}" media="screen">
    <link type="text/css" rel="stylesheet" href="{% static 'vendor/leaflet/easy-button.css' %}"> 
    <!-- Leaflet js -->
    <script type="text/javascript" src="{% static 'vendor/leaflet/leaflet.js' %}"></script>
    <!-- Leaflet Timedimension plugin -->
    <script type="text/javascript" src="{% static 'vendor/leaflet/leaflet.timedimension.min.js' %}"></script>
    <script type="text/javascript" src="{% static 'vendor/leaflet/leaflet.timedimension.layer.wms.cstm.js' %}"></script>
    <!-- Leaflet Button plugin -->
    <script src="{% static 'vendor/leaflet/easy-button.js' %}"></script>
    <!-- Custom Leaflet Toolbar -->
    <script src="{% static 'vendor/leaflet/L.Control.CstmToolbar.js' %}"></script>
    <!-- Leaflet Bookmarks -->
    <script src="{% static 'vendor/leaflet/Leaflet.Bookmarks.min.js' %}"></script>
    <!-- Leaflet Loading -->
    <script src="{% static 'vendor/leaflet/Control.Loading.js' %}"></script>

    <script type="text/javascript">
        // Global vars
        var stationTypes = {{ station_types|safe }};
        var bboxLayer = null;
        var bboxTypes = {{ bbox_types|safe }};
        var pointsGroup = null;
        var linesGroup = null;
        var services = {};
        var services_counter = {};
        var layers_notime = [];
        var pointState = false; // used only if 'addpoint' tool is added to leaflet custom toolbar
        var boundaries = {};
        var boundariesGroup = null;
        var rasters = {};
        var rastersGroup = null;

        var images_per_deploy = [];

        // console.log(images_list);

        var chosen_obs; //coordinates

        var curr_image;

        var coast_line;

        var opacity_value = 0;

        // var n_images = images_list.length;

        var n_images_deploy;
        var images_selected = [];
        var sat_deploy;

        // Sub-class to add new icon to control layer
        L.Control.Layers.TogglerIcon = L.Control.Layers.extend({
            options: {
                // Optional base CSS class name for the toggler element
                togglerClassName: undefined
            },

            _initLayout: function(){
                L.Control.Layers.prototype._initLayout.call(this);
                if (this.options.togglerClassName) {
                    console.log(this.options.togglerClassName);
                    //L.DomUtil.addClass(this._layersLink, this.options.togglerClassName);
                    this._layersLink.style.backgroundImage = "url(" + this.options.togglerClassName + ")";
                }
            }   
        });

        // Basemap Tiles
        var Esri_WorldGrayCanvas = L.tileLayer('https://server.arcgisonline.com/ArcGIS/rest/services/Canvas/World_Light_Gray_Base/MapServer/tile/{z}/{y}/{x}', {
            attribution: 'Tiles &copy; Esri &mdash; Esri, DeLorme, NAVTEQ',
            maxZoom: 16
        });
        var Esri_WorldStreetMap = L.tileLayer('https://server.arcgisonline.com/ArcGIS/rest/services/World_Street_Map/MapServer/tile/{z}/{y}/{x}', {
            attribution: 'Tiles &copy; Esri &mdash; Source: Esri, DeLorme, NAVTEQ, USGS, Intermap, iPC, NRCAN, Esri Japan, METI, Esri China (Hong Kong), Esri (Thailand), TomTom, 2012'
        });
        var Esri_WorldImagery = L.tileLayer('https://server.arcgisonline.com/ArcGIS/rest/services/World_Imagery/MapServer/tile/{z}/{y}/{x}', {
            attribution: 'Tiles &copy; Esri &mdash; Source: Esri, i-cubed, USDA, USGS, AEX, GeoEye, Getmapping, Aerogrid, IGN, IGP, UPR-EGP, and the GIS User Community'
        });

        var baseMaps = {
            "Esri WorldStreetMap": Esri_WorldStreetMap,
            "Esri WorldGrayCanvas": Esri_WorldGrayCanvas,
            "Esri WorldImagery": Esri_WorldImagery
        };

        var sat_images;
        
        // Get today's date
        var today = new Date();
        today.setUTCHours(1);
        today.setUTCMinutes(0, 0, 0);

        // Get yesterday
        var yesterday = new Date();
        yesterday.setDate(today.getDate() - 1);
        yesterday.setUTCHours(1);
        yesterday.setUTCMinutes(0, 0, 0);

        // Build Map
        var map = L.map('map', {
            minZoom: 2,
            maxZoom: 16,
            zoomControl: false,
            layers: [Esri_WorldStreetMap],
            attributionControl: true,
            timeDimension: true,
            timeDimensionOptions: {
                timeInterval: yesterday.toISOString() + "/PT71H",
                period: "PT1H",
                currentTime: today.getTime(),
                //loadingTimeout: 10000
            },
        });

        var overlayMaps = {};
        /*
        // Add Sentinel Imagery to map
        var sentinelURL = 'http://services.sentinel-hub.com/v1/wms/1993aa8d-af9b-487e-92cb-4bfdfc6ae9a0?showLogo=false';
        var sentinelHub = L.tileLayer.wms(sentinelURL, {
            attribution: '&copy; <a href="http://www.sentinel-hub.com/" target="_blank">Sentinel Hub</a>',
            version: '1.3.0',
            layers: '1_NATURAL_COL0R,S2.DATE,S2.TIME',
            styles: '',
            format: 'image/jpeg',
            transparent: true,
            tileSize: 512,
            preview: '3',
            atmFilter: '',
            gain: 1,
            gamma: 1,
        });
        overlayMaps['Sentinel Imagery'] = sentinelHub;
        // Set sentinel as first (bottom) layer
        sentinelHub.setZIndex(1);
        */

        var info = L.control({position:'bottomright'});

        function configureInfo(images_deploy){

                info.onAdd = function(mymap){
                    this._div = L.DomUtil.create('div', 'info'); // create a div with a class "info"
                    this._div.id = "information";
                    this.update();
                    return this._div;   
                }

                info.update = function(){
                    this._div.innerHTML = getImageData(); //'<h4>9 de outubro de 2020</h4>';
                    //this._div.innerHTML += '<div class="slidecontainer"><input id="opacity_slider" type="range" min="0" max="100" value="0"></div>';
                    this._div.innerHTML += '<nav id="pagination_box"';
                    this._div.innerHTML += '<ul class="pagination justify-content-center"><li class="page-item" id="go_to_zero"><a><i style="font-size:18px" class="fa">&#xf049;</i></a></li>' 
                    + '<li class="page-item" id="go_previous"><a class="page-link"><i style="font-size:18px" class="fa">&#xf048;</i></a></li>'
                    + '<li class="page-item" id="go_next"><a class="page-link" href="#"><i style="font-size:18px" class="fa">&#xf051;</i></a></li>'
                    + '<li class="page-item" id="go_to_last"><a class="page-link"><i style="font-size:18px" class="fa">&#xf050;</i></a></li></ul></nav>';
                }

                function getImageData(){
                    image_date = images_deploy[curr_image]['properties']['date'];

                    return '<h4 id="imageDate">' + image_date + '</h4>';
                }
        }

        function updateImageData(){
            image_date = images_selected[curr_image]['properties']['date'];

            document.getElementById("imageDate").innerHTML = image_date;
        }

        function addSatelliteLayer(deploy, n_images_deploy, images_deploy, bounds){

            console.log(images_deploy);

            if(coast_line){
                map.removeLayer(coast_line);
                removeSatChecks(deploy);
            }

            images_selected = images_deploy;

            if(images_deploy.length > 0){

                console.log(n_images_deploy);

                curr_image = n_images_deploy - 1;

                coast_line = new L.tileLayer('/raster/tiles/' + images_deploy[curr_image]['properties']['id'] + '/{z}/{x}/{y}.png' + '?colormap={"continuous":"True","from":[0,0,0],"over":[0,0,128],"to":[0,0,255],"range":[-0.1,1.1]}');
                coast_line.setOpacity(0.5);

                console.log(coast_line);

                boundaries = [[bounds[1], bounds[0]], [bounds[3], bounds[2]]]

                map.fitBounds(boundaries, {padding: [50,50]});

                coast_line.addTo(map);

                sat_images = {
                    "Satellite Image": coast_line
                };

                configureInfo(images_deploy);

                info.addTo(map);
                info.update();

                if(images_deploy.length > 1)
                        restartSlideshow(true);
                else{
                    document.getElementById("go_to_zero").classList.add("disabled");
                    document.getElementById("go_previous").classList.add("disabled");
                    document.getElementById("go_next").classList.add("disabled");
                    document.getElementById("go_to_last").classList.add("disabled");
                }
            }
        }

        function restartSlideshow(restart_slideshow_flag){
            document.getElementById("go_to_zero").onclick = function() {changeSequence("first")};
            document.getElementById("go_previous").onclick = function() {changeSequence("prev")};
            document.getElementById("go_next").onclick = function() {changeSequence("next")};
            document.getElementById("go_to_last").onclick = function() {changeSequence("last")};

            if(restart_slideshow_flag){
                document.getElementById("go_to_zero").classList.remove("disabled");
                document.getElementById("go_previous").classList.remove("disabled");
                document.getElementById("go_next").classList.add("disabled");
                document.getElementById("go_to_last").classList.add("disabled");
            }
        }
        
        function updateImage(){
            map.removeLayer(coast_line);
            
            coast_line = new L.tileLayer('/raster/tiles/' + images_selected[curr_image]['properties']['id'] + '/{z}/{x}/{y}.png' + '?colormap={"continuous":"True","from":[0,0,0],"over":[0,0,128],"to":[0,0,255],"range":[-0.1,1.1]}');
            coast_line.setOpacity(0.5);

            console.log(coast_line);

            sat_images = {
                "Satellite Image": coast_line
            };

            coast_line.addTo(map);

            updateImageData();

            if(images_selected.length > 1)
                restartSlideshow(false);
            else{
                document.getElementById("go_to_zero").classList.add("disabled");
                document.getElementById("go_previous").classList.add("disabled");
                document.getElementById("go_next").classList.add("disabled");
                document.getElementById("go_to_last").classList.add("disabled");
            }
        }

        function checkValues(){
            if(curr_image <= 0){
                curr_image = 0;
                document.getElementById("go_to_zero").classList.add("disabled");
                document.getElementById("go_previous").classList.add("disabled");
                document.getElementById("go_next").classList.remove("disabled");
                document.getElementById("go_to_last").classList.remove("disabled");
            }

            if(curr_image > 0 && curr_image <= images_selected.length - 1){
                document.getElementById("go_to_zero").classList.remove("disabled");
                document.getElementById("go_previous").classList.remove("disabled");
                document.getElementById("go_next").classList.remove("disabled");
                document.getElementById("go_to_last").classList.remove("disabled");
            }

            if(curr_image >= images_selected.length - 1){
                curr_image = images_selected.length - 1;
                document.getElementById("go_next").classList.add("disabled");
                document.getElementById("go_to_last").classList.add("disabled");
            }    
        }

        function changeSequence(sequence){
            console.log(sequence);
            console.log("ENTREI:" + curr_image);
            if(sequence == "prev"){
                console.log("previous");
                curr_image = curr_image - 1;
            }
        
            else if(sequence == "next"){
                console.log("next up");
                curr_image++;
            }
            
            else if(sequence == "first"){
                console.log("first image");
                curr_image = 0;
                document.getElementById("go_to_zero").classList.add("disabled");
                document.getElementById("go_previous").classList.add("disabled");
            }
            
            else if(sequence == "last"){
                console.log("last image");
                curr_image = images_selected.length - 1;
                document.getElementById("go_next").classList.add("disabled");
                document.getElementById("go_to_last").classList.add("disabled");
            }
            
            checkValues();

            console.log("FINAL:" + curr_image);

            updateImage();
        }

        function removeSatellites(deploy_id){
            map.removeLayer(coast_line);
            //layerControl2.remove();
            info.remove();
        }

        {% if bbox %}
        // Add BBox
        bboxLayer = L.geoJson({{ bbox|safe }}, {
            style: function(feature) {
                var borderColor = '#333';
                bboxTypes.forEach(function(item, index) {
                    if (item['type'] == feature.properties.bbox_type) borderColor = item['color'];
                });
                return {
                    color: borderColor,
                    weight: 2,
                    fillOpacity: .20,
                    fillColor: '#ffffff',
                    dashArray: '20,15',
                    lineJoin: 'round',
                    interactive: false, // disables pointer events on the layer's features
                };
            }
        });
        bboxLayer.addTo(map);
        {% endif %}

        // Build Custom Toolbar
        var tlbButtons = [
            {'id': 'zoomin', 'classes': 'glyphicon glyphicon-plus', 'title': '{% trans "Aproximar" %}'},
            {'id': 'zoomout', 'classes': 'glyphicon glyphicon-minus', 'title': '{% trans "Afastar" %}'},
            {'id': 'fullout', 'classes': 'glyphicon glyphicon-globe', 'title': '{% trans "Afastar à zona de atuação" %}'},
            {'id': 'addpoint', 'classes': 'glyphicon glyphicon-screenshot', 'title': '{% trans "Ativar/desativar ferramenta Adicionar ponto aos gráficos" %}', 'active': false}
        ];

        // Set map click event
        map.on('click', onMapClick);

        // Add custom Zoom Control
        var zoomControl = L.control.cstmtoolbar({
            id: 'map_tlb',
            position: 'topleft',
            classes : 'btn-group-vertical btn-group-sm',
            buttons: tlbButtons
        });

        map.addControl(zoomControl);
        $('#maptools').append(zoomControl.getContainer());

        // Add Bookmarks Control
        var bookmarksControl = new L.Control.Bookmarks({'position': 'topleft'});
        map.addControl(bookmarksControl);
        $('#maptools').append(bookmarksControl.getContainer());

        // Add custom LayerControl
        var layerControl = L.control.layers(baseMaps, overlayMaps, {'position': 'topleft'}).addTo(map);
        $('#maptools').append(layerControl.getContainer());
        // Add custom Layer Control for satellite
        //var layerControl2;

        // Add Legend
        var legend = L.control({position: 'topright'});
        legend.onAdd = function (map) {
            var div = L.DomUtil.create('div', 'legend');
            L.DomEvent.disableClickPropagation(div);

            var divContent = '<button type="button" class="right tgl-leg"><span class="glyphicon glyphicon-remove-circle"></span></button>';
            divContent += '<div id="legpanel"><span class="title">{% trans "Legenda" %}</span>';

            {% if bbox %}
            //BBox Legend
            divContent += '<span class="subtitle">{% trans "Zona" %}</span>';
            labels = [];
            bboxTypes.forEach(function(item) {
                labels.push('<span><i class="square" style="border: dashed 2px ' + item['color'] + '"></i> ' + item['label'] + '</span>');
            });
            divContent += labels.join('<br/>');
            {% endif %}

            divContent += '<span class="subtitle">{% trans "Estação" %}</span>';
            labels = [];
            stationTypes.forEach(function(item) {
                labels.push('<span><i class="circle" style="background-color:' + item['color'] + '"></i> ' + item['label'] + '</span>');
            });
            divContent += labels.join('<br/>');
            divContent += '<hr class="tight" />';
            divContent += '<div id="accordion_legend" class="accordion panel-group"></div>';
            divContent += '</div>';

            div.innerHTML = divContent;
            return div;
        };
        legend.addTo(map);

        // Prevent map dragging on action over legend
        legend.getContainer().addEventListener('mouseover', function() {
            map.dragging.disable();

        });
        legend.getContainer().addEventListener('mouseout', function() {
            map.dragging.enable();
        });
        legend.getContainer().addEventListener('click', function() {
            return false;
        });

        // Loading Tiles events, show/hide spinner
        var loadingControl = L.Control.loading({
            separate: true
        });
        loadingControl.addTo(map);
        $('#loadingcontrol').append(loadingControl.getContainer());

        // Extend Time Dimension Control to format datetime
        L.Control.TimeDimensionCustom = L.Control.TimeDimension.extend({
            _getDisplayDateFormat: function(date){
                return formatDateHour(date);
            }
        });

        // Add Time Dimension Control to map
        var timeDimensionControl = new L.Control.TimeDimensionCustom({
            //player: player,
            speedSlider: false,
            autoPlay: false,
            playerOptions: {
                transitionTime: 2500,
                buffer: 0,
                loop: false,
            }
        });
        timeDimensionControl.addTo(map);
        $('#timecontrol').append(timeDimensionControl.getContainer());

        // TimeDimension events
        map.timeDimension.on('timeloading', function(event) { map.fireEvent('dataloading', event); });
        map.timeDimension.on('timeload', function(event) {
            map.fireEvent('dataload', event);

            // Update plotline position according to new time loaded
            update_charts_plotlines();

            // If there are services which do not have this time we alert user
            var message = '';
            for (var i=0; i<layers_notime.length; i++) {
                // Get service
                var service = services[layers_notime[i]];
                var avtimes = service._availableTimes;
                if (avtimes.length > 0) {
                    var period = formatDateHour(new Date(avtimes[0]));
                    period += ' / ' + formatDateHour(new Date(avtimes[avtimes.length-1]));
		            message += service.options.layer_name + ': ' + '{% trans "apenas tem dados para o seguinte período: " %}' + period + '<br/>';
                }
            }
            if (message != '') {
                message.slice(0, -5);
                show_alert(message, 7000);
                layers_notime = [];
            }
        });

        // On map click (if addpoint tool selected)
        function onMapClick(e) {
            if (pointState) {
                // Get active deploy
                var deploy = $('.deploy.panel-collapse.in').data('deploy');

                // If active deploy exists
                if (deploy != null && deploy != 'undefined') {
                    var lat = e.latlng.lat.toFixed(4);
                    var lon = e.latlng.lng.toFixed(4);
                    var test_point = new L.latLng(lat, lon);

                    // Check if service extent contains added point
                    var pointin = false;
                    var bbox = $('#bbox_' + deploy).data('extent');
                    var rect = L.rectangle([[bbox[3],bbox[0]],[bbox[1],bbox[2]]]);
                    if (rect.getBounds().contains(test_point)) pointin = true;

                    if (pointin) {
                        var station_code = lat + '_' + lon;
                        var station_name = 'ID:' + deploy + ' [' + lat + ',' + lon + ']';

                        // Fill name and hidden inputs
                        $("#stat_code_" + deploy).val(station_code);
                        $("#stat_name_" + deploy).val(station_name);
                        $("#stat_type_" + deploy).val('R');
                        $("#stat_lat_" + deploy).val(lat);
                        $("#stat_lon_" + deploy).val(lon);

                        // Get random unused color
                        color = getRandomColor();
                        while (colors.indexOf(color) != -1) {
                            color = getRandomColor();
                        }
                        $("#stat_color_" + deploy).val(color);

                        openPopup(deploy, station_name, station_code);
                    } else {
                        show_alert('{% trans "Por favor selecione um ponto dentro da extensão do sistema selecionado." %}', 3000);
                    }
                } else {
                    show_alert('{% trans "Por favor ative (expanda) um sistema do menu." %}', 3000);
                }
            }
        }

        // Add new virtual station marker to the map
        function addPoint2Map(deploy, station_code, station_name, lat, lon, color) {
            // Build Popup Content
            var p = document.createElement('p');
            $(p).html(station_name + '<br/><hr/>');

            var edit_btn = document.createElement('button');
            $(edit_btn).addClass('btn btn-primary btn-xs');
            $(edit_btn).html('<span class="glyphicon glyphicon-stats"></span>');
            $(edit_btn).attr({
                'type': "button",
                'title': "{% trans 'Adicionar/Remover séries' %}",
            });
            $(edit_btn).click(function() {
                // Fill hidden inputs
                $("#stat_code_" + deploy).val(station_code);
                $("#stat_name_" + deploy).val(station_name);
                $("#stat_type_" + deploy).val("R");
                $("#stat_lat_" + deploy).val(lat);
                $("#stat_lon_" + deploy).val(lon);
                $("#stat_color_" + deploy).val(color);

                // Set and open modal
                openPopup(deploy, station_name, station_code);
            });
            var remove_btn = document.createElement('button');
            $(remove_btn).addClass('btn btn-danger btn-xs');
            $(remove_btn).text('{% trans "Remover" %}');
            $(remove_btn).attr({'type': "button"});
            $(remove_btn).click(function() {
                // Remove series from charts
                removeStationSeries(station_name);

                // Remove point from map
                pointsGroup.removeLayer(station_code);
            });

            // Append all elements to a div
            var dPopup = document.createElement('div');
            $(dPopup).append(p, edit_btn, remove_btn);

            // Add marker to map with popup on click with remove button
            var MarkerOptions = {
                color: '#FFFFFF',
                fillColor: color,
                fillOpacity: 0.8,
                radius: 5,
                weight: 2,
            };

            // Add point to map
            var circle = L.circleMarker([lat, lon], MarkerOptions).bindPopup(dPopup);
            circle._leaflet_id = station_code;
            pointsGroup.addLayer(circle);
        }

        // Check if station marker has already been added to the pointsGroup
        function pointInGroup(station_code) {
            var marker = pointsGroup.getLayer(station_code);
            if (marker) {
                return true;
            } else {
                return false;
            }
        }

        // Load WMS Service
        function loadWMSLayer(elem) {
            var colorscalerange = '', logscale = false, belowmincolor = 'extend', abovemaxcolor = 'extend';

            var deploy = $(elem).data('deploy');
	        var layer_id = deploy + '-' + $(elem).attr('id');
	        var theme = $(elem).data('theme');
            var label = $(elem).data('name');
            var name = 'ID:' + deploy + ' ' + label;
            var style = $(elem).data('style');
            var unit = $(elem).data('unit');
            var min = ($(elem).attr('data-min')) ? $(elem).data('min') : null;
            var max = ($(elem).attr('data-max')) ? $(elem).data('max') : null;
            var logscale = $(elem).data('log');

            //if (min && max) colorscalerange = min + ',' + max;
            colorscalerange = min + ',' + max;

            if (min) belowmincolor = 'transparent';

            var numcolorbands = 20;
            //if (theme=='zcor') numcolorbands = 10;

            var dataset = did.replace('{id}', deploy);
            var layer = dataset + '/' + theme;

            var level = 0;
            var level_obj = $('#level_' + deploy).val();
            if (level_obj != undefined){
                level = level_obj;
                level = level - 1;
            }

            if (!(layer_id in services)) {
                // Test if WMS exists before loading by reading GetCapabilities (DATASET specific for ncWMS)
                var test_wms = servicepath + "?SERVICE=WMS&REQUEST=GetCapabilities&VERSION=1.1.1&DATASET=" + dataset;
                $.ajax({
                    type: "get",
                    url: test_wms,
                    success: function() {
                        // Set WMS config
                        var wmsLayer = new L.tileLayer.wms(servicepath, {
                            'version': '1.3.0',
                            'crs': L.CRS.EPSG3857,
                            'layers':  layer,
                            'transparent': true,
                            'format': 'image/png',
                            'styles': style,
                            'abovemaxcolor': abovemaxcolor,
                            'belowmincolor': belowmincolor,
                            'numcolorbands': 20,
                            'colorscalerange': colorscalerange,
                            'logscale': logscale,
                            'attribution': "[" + name + "©LNEC]",
                            'elevation': level
                        });

                        // Create service
                        var service = L.timeDimension.layer.wms.cstm(wmsLayer, {
                            'layer_id': layer_id,
                            'layer_name': name,
                            'updateTimeDimension': false,
			                'updateTimeDimensionMode': 'replace',
			                'updateCurrentTime': false,
                            'cacheBackward': 0,
                            'cacheForward': 0,
                        });

			            console.log(service);

                        service.on('timeload', function(event) { map.fireEvent('dataload', event); });

                        // Save the service to a global dictionary
                        services[layer_id] = service;
                        services_counter[deploy] = 0;
                    },
                    error: function (request, status, error) {
                        // update time dimension label
                        $('#period_' + layer_id).html('{% trans "sem dados" %}');
                        // disable checkbox and stations
                        $('input[type="checkbox"][name="theme"][data-deploy="' + deploy + '"][data-theme="' + theme + '"]').attr('disabled', "disabled");
                    }
                });
            }
        }

        // Add WMS Layer to services LayerGroup and map
        function addWMSLayer(elem) {
            var deploy = $(elem).data('deploy');
            var layer_id = deploy + '-' + $(elem).attr('id');
            var theme = $(elem).data('theme');
            var label = $(elem).data('name');
            var name = 'ID:' + deploy + ' ' + label;
            var style = $(elem).data('style');
            var unit = $(elem).data('unit');
            var min = ($(elem).attr('data-min')) ? $(elem).data('min') : null;
            var max = ($(elem).attr('data-max')) ? $(elem).data('max') : null;
            var log = $(elem).data('log');

            var dataset = did.replace('{id}', deploy);
            var layer = dataset + '/' + theme;

            console.log("--------layer------");
            console.log(layer_id);

            // Get service
            var service = services[layer_id];
            var counter = services_counter[deploy];
            services_counter[deploy] = counter + 1;

            /// Add Layer to map
            service.addTo(map);
            service.bringToFront();
            service.setOpacity(1);

            // Zoom to layer
            var extent = $('#bbox_' + deploy).data('extent');
            // Fit to extent [xmin, ymin, xmax, ymax]
            if(services_counter[deploy] < 2)
                if (extent.length > 0) map.fitBounds([[extent[3],extent[0]],[extent[1],extent[2]]], {padding: [50,50]});

            var colorscalerange = '', logscale = '', belowmincolor = 'extend', abovemaxcolor = 'extend';
            //if (min && max) colorscalerange = '&COLORSCALERANGE=' + min + ',' + max;
            colorscalerange = '&COLORSCALERANGE=' + min + ',' + max;

            if (min) belowmincolor = 'transparent';

            if (log) logscale = '&LOGSCALE=true';

            // Velocities: style for legend must be be changed - show magnitude only
            if ( theme.endsWith('-group') ) style = 'default-vector/' + style.split('/')[1];

            var legend_url = servicepath + "?REQUEST=GetLegendGraphic&LAYERS=" + layer + "&STYLES=" + style +
                "&NUMCOLORBANDS=20&ABOVEMAXCOLOR=" + abovemaxcolor + "&BELOWMINCOLOR=" + belowmincolor +
                "&WIDTH=60&HEIGHT=200" + logscale + colorscalerange;

            // Build Legend panel
            createLegend(layer_id, name, unit, legend_url);

            // check parent checkbox - only here we can be sure wms was loaded properly
            $('#chk_' + deploy).attr('checked', 'checked');

            return true;
        }

        // Remove WMS Layer from services LayerGroup
        function removeWMSLayer(elem) {
            var deploy = $(elem).data('deploy');
            var layer_id = deploy + '-' + $(elem).attr('id');
            var theme = $(elem).data('theme');

            // Get service
            var service = services[layer_id];

            var counter = services_counter[deploy];
            services_counter[deploy] = counter - 1;

            if(services_counter[deploy] <= 0)
                services_counter[deploy] = 0;

            // Remove and delete service
            map.removeLayer(service);

            // remove from legend
            $('[data-layer="' + layer_id + '"]').remove();
        }

        // Add Station to map
        function addStationMap(elem) {
            var deploy = $(elem).data('deploy');
            var sid = $(elem).data('code');
            var stype = $(elem).data('type');
            var name = $(elem).data('name');
            var lat = $(elem).data('lat');
            var lon = $(elem).data('lon');
            var cstation = $(elem).data('cstation');
            var feature = {"properties": {"source": $(elem).data('source'), "owner": $(elem).data('owner'), "params": $(elem).data('params')}};

            // Circle settings
            var fillColor = '#333', rad = 5, fillOpacity = 0.8, weight = 2;

            // Get station color
            var obsColor = null;
            stationTypes.forEach(function(item, index) {
                if (stype == item['type']) fillColor = item['color'];
                if (item['type'] == 'O') obsColor = item['color'];
            });

            // Build popup info
            var oid = sid.split('_')[1];    // observation station id
            var popupCtn = buildPopup(oid, stype, name, cstation, feature);

            if (stype == 'C') {
                // Also add to map the observation station
                var oMarkerOptions = {radius: 5, fillColor: obsColor, color: "#333", weight: weight, opacity: fillOpacity, fillOpacity: fillOpacity, riseOnHover: false};
                var oLat = parseFloat(cstation.substring(cstation.indexOf('(')+1, cstation.indexOf(',')));
                var oLon = parseFloat(cstation.substring(cstation.indexOf(',')+2, cstation.indexOf(')')));
                var osid = sid.replace('C', 'O');
                var oPopup = buildPopup(oid, 'O', cstation.split(' (')[0], null, feature);
                var oPoint = new L.LatLng(oLat, oLon);
                var oPointMarker = L.circleMarker(oPoint, oMarkerOptions).bindPopup(oPopup);
                oPointMarker._leaflet_id = osid;
                oPointMarker.on({
                  mouseover: function(){ oPointMarker.openPopup(); },
                  mouseout: function(){ oPointMarker.closePopup(); },
                });
                pointsGroup.addLayer(oPointMarker);

                // Also add to map the connecting line if position different
                if (oLat != lat || oLon != lon) {
                    createLine([lat, lon], [oLat, oLon], sid.replace('C', 'L'));
                }

                // Increase comparision station radius to overlay observation station
                rad = 10;
            }

            var pointMarkerOptions = {radius: rad, fillColor: fillColor, color: "#333", weight: weight, opacity: fillOpacity, fillOpacity: fillOpacity, riseOnHover: true};
            var cPoint = new L.LatLng(lat, lon);
            var pointMarker = L.circleMarker(cPoint, pointMarkerOptions).bindPopup(popupCtn);
            pointMarker.on({
              mouseover: function(){ pointMarker.openPopup(); },
              mouseout: function(){ pointMarker.closePopup(); },
            });
            pointMarker._leaflet_id = sid;
            pointsGroup.addLayer(pointMarker);
        }

        // Remove Station from map
        function removeStationMap(elem) {
            var sid = $(elem).data('code');
            var stype = $(elem).data('type');

            var layer = map._layers[sid];
            // Remove point in map
            pointsGroup.removeLayer(layer);

            if (stype == 'C') {
                // Remove observation station
                var oPoint = pointsGroup.getLayer(sid.replace('C', 'O'));
                if (oPoint) pointsGroup.removeLayer(oPoint);

                // Remove connecting line if exists
                var connectline = linesGroup.getLayer(sid.replace('C', 'L'));
                if (connectline) linesGroup.removeLayer(connectline);
            }
        }

        // Added: Create custom legend div
        function createLegend(layer, label, unit, legendpath) {
            // Collapse other panels in accordion before adding
            $('#accordion_legend .panel-collapse').addClass('collapse');

            var layerid = layer.replace('/', '_');

            var d = document.createElement('div');
            $(d).attr('data-layer', layer);
            $(d).addClass('panel');

            var a = document.createElement('a');
            $(a).addClass('accordion-toggle collapsed');
            $(a).attr('data-toggle', 'collapse');
            $(a).attr('data-parent', '#accordion_legend');
            $(a).attr('href', '#leg_' + layerid);
            $(a).attr('title', '{% trans "ver esquema de cores" %}');
            $(a).attr('aria-expanded', false);
            $(a).html(label + '<span title="{% trans "arrastar" %}" class="drag glyphicon glyphicon-move"></span>');

            var d2 = document.createElement('div');
            $(d2).attr('id', 'leg_' + layerid);
            $(d2).addClass('panel-collapse collapse');
            $(d2).attr('aria-expanded', false);
            var divcontent = '<span class="unit"><strong>unit:</strong> ' + unit + '</span>';
            divcontent += '<br/><img src="' + legendpath + '" alt="legend" />';
            $(d2).html(divcontent);

            var d3 = document.createElement('div');
            var d4 = document.createElement('div');
            $(d4).attr('data-layer', layer);
            $(d4).addClass('slider');
            // Initiate opacity slider
            $(d4).slider({
                range: "min",
                min: 0,
                max: 1,
                value: 1,
                step: .1,
                slide: function(event, ui) {
                    var id_layer = $(this).attr('data-layer');
                    var layer = services[id_layer];
                    layer.setOpacity(ui.value);
                    $(ui.handle).blur();
                }
            });

            $(d3).append('<span class="small">{% trans "opacidade" %}</span>', d4)
            $(d).append(a, '<br/>', d2, d3);
            $('#accordion_legend').prepend(d);
        }

        function buildPopup(id, stype, name, cstation, feature) {
            // Builds popup html content (used on stations geojson load and whenever user creates new stations)
            var popupCtn = '<p>' + name + '</p>';
            if (stype == 'O' || stype == 'C') {
                // Get comparison station info
                if (stype == 'C') popupCtn += '<hr/><strong>{% trans "Comparação" %}</strong><br/>' + cstation;
                popupCtn += '<hr/><strong>{% trans "Código" %}</strong> ' + id.replace('O_', '');
                popupCtn += '<br/><strong>{% trans "Fonte" %}</strong> ' + feature.properties.source;
                popupCtn += '<br/><strong>{% trans "Origem" %}</strong> ' + feature.properties.owner;
                popupCtn += '<br/><strong>{% trans "Parâmetros" %}</strong> ' + feature.properties.params;
            }
            return popupCtn;
        }

        function createLine(station, cstation, lid) {
            // Build line between points and add to map
            var lpoints = [];
            lpoints.push(station);
            lpoints.push(cstation);

            var connectline = new L.polyline(lpoints, {
                color: 'red',
                weight: 1,
                opacity: 1,
            });
            connectline._leaflet_id = lid;
            linesGroup.addLayer(connectline);
        }

        // Format selected Day date string
        function formatDate(d) {
            var year = d.getFullYear();
            var month = ("0" + (d.getMonth()+1)).slice(-2);
            var day = ("0" + d.getDate()).slice(-2);
            return year + "-" + month + "-" + day;
        }

        // Format ISOString date to string
        function formatDateHour(d) {
            var date = d.toISOString();
            return date.replace('T', ' ').replace(':00.000Z', '');
        }

        // Get hour from date as number
        function getHour(d) {
            return d.getHours();
        }

        // Get date's Day of year
        function daysIntoYear(date){
            var day = (Date.UTC(date.getFullYear(), date.getMonth(), date.getDate()) - Date.UTC(date.getFullYear(), 0, 0)) / 24 / 60 / 60 / 1000;
            return date.getFullYear() + padLeft(day, 3);
        }

        // Pad numbers
        function padLeft(nr, n, str){
            return Array(n-String(nr).length+1).join(str||'0')+nr;
        }

        // On Document Ready
        $(function(){
            // Set basemap tiles on bottom
            Esri_WorldStreetMap.setZIndex(0);
            Esri_WorldGrayCanvas.setZIndex(0);
            Esri_WorldImagery.setZIndex(0);

            if (bboxLayer !== null) {
                map.fitBounds(bboxLayer.getBounds());
            } else {
                map.fitWorld();
            }

            pointsGroup = new L.layerGroup().addTo(map);
            linesGroup = new L.layerGroup().addTo(map);
            boundariesGroup = new L.layerGroup().addTo(map);

            // Set legend color
            stationTypes.forEach(function(item) {
                $("<style type='text/css'> .icon" + item['type'] + " { background-color: " + item['color'] + ";} </style>").appendTo("head");
            });

            // Load all services on map load
            $('input[type="checkbox"][name="theme"]').each(function() {
                // Load to map
                loadWMSLayer(this);
            });

            $('button.zoomto').click(function() {
                var lat = $(this).data('lat');
                var lon = $(this).data('lon');
                // set the view
                map.setView([lat, lon], 13);
            });

            $('button.bbox').click(function() {
                var bbox = $(this).data('extent');
                if (bbox.length > 0) map.fitBounds([[bbox[3],bbox[0]],[bbox[1],bbox[2]]], {padding: [50,50]});
            });

            $('button.view').click(function() {
                var deploy = $(this).data('deploy');
                var bbox = $(this).data('extent');

                if (!$(this).hasClass('active')) {
                    $(this).addClass('active');
                    // Change icon also
                    var span = $(this).find('span');
                    span.removeClass('glyphicon-eye-open');
                    span.addClass('glyphicon-eye-close');

                    // check parent checkbox
                    $('#chk_' + deploy).attr('checked', 'checked');

                    if (!(deploy in boundaries)) {
                        // Get boundaries from server via client-side if not done before
                        $.ajax({
                            type: 'GET',
                            url: '{% url 'front:get_boundaries' deploy_id=0 %}'.replace(/0/, deploy),
                            success: function(response) {
                                var boundaries_geojson = JSON.parse(response['boundaries']);
                                if (boundaries_geojson) {
                                    var boundariesLayer = L.geoJson(boundaries_geojson, {
                                        style: function(feature) {
                                            return {
                                                color: "#777",
                                                weight: 2,
                                                fillOpacity: .20,
                                                fillColor: '#ffffff',
                                                dashArray: '20,15',
                                                lineJoin: 'round',
                                                interactive: false, // disables pointer events on the layer's features
                                            };
                                        }
                                    });
                                    boundariesLayer._leaflet_id = deploy;

                                    // Add to map
                                    boundariesGroup.addLayer(boundariesLayer);

                                    // Save to global variable so we don't have to request server-side again
                                    boundaries[deploy] = boundariesLayer;

                                    // Zooms to boundaries
                                    map.fitBounds(boundariesLayer.getBounds(), {padding: [50,50]});
                                } else {
                                    if (bbox.length > 0) map.fitBounds([[bbox[3],bbox[0]],[bbox[1],bbox[2]]], {padding: [50,50]});
                                    show_alert('{% trans "Não foi possível carregar as fronteiras." %}', 5000);
                                }
                            },
                            error: function(e, x, r) {
                                if (bbox.length > 0) map.fitBounds([[bbox[3],bbox[0]],[bbox[1],bbox[2]]], {padding: [50,50]});
                                show_alert('{% trans "Não foi possível carregar as fronteiras." %}', 5000);
                            }
                        });
                    } else {
                        // Get boundaries from global variable (loaded before from server)
                        var boundariesLayer = boundaries[deploy];
                        if (typeof(boundariesLayer) != 'undefined') {
                            // Add to map
                            boundariesGroup.addLayer(boundariesLayer);

                            // Zooms to boundaries
                            map.fitBounds(boundariesLayer.getBounds(), {padding: [50,50]});
                        } else {
                            if (bbox.length > 0) map.fitBounds([[bbox[3],bbox[0]],[bbox[1],bbox[2]]], {padding: [50,50]});
                            show_alert('{% trans "Não foi possível carregar as fronteiras." %}', 5000);
                        }
                    }
                } else {
                    $(this).removeClass('active');
                    // Change icon also
                    var span = $(this).find('span');
                    span.removeClass('glyphicon-eye-close');
                    span.addClass('glyphicon-eye-open');

                    // Removes boundaries
                    var boundariesLayer = boundariesGroup.getLayer(deploy);
                    if (typeof(boundariesLayer) != 'undefined') boundariesGroup.removeLayer(boundariesLayer);

                    // remove parent checkbox if all removed
                    removeChecks(deploy);
                }
            });
            $('button.sat').click(function() {
                var deploy = $(this).data('deploy');
                var bbox = $(this).data('extent');

                console.log(bbox);

                if (!$(this).hasClass('active')) {

                    if (!(deploy in rasters)){
                        $.ajax({
                            type: 'GET',
                            url: '{% url 'get_rasters' deploy_id=0 %}'.replace(/0/, deploy),
                            success: function(response) {
                                var rasters_geojson = response['rasters'];
                                if (rasters_geojson) {
                                    if(rasters_geojson.length > 0){
                                        $(this).addClass('active');

                                        $('#chk_sat' + deploy).attr('checked', 'checked');

                                        curr_image = rasters_geojson.length - 1;

                                        addSatelliteLayer(deploy, rasters_geojson.length, rasters_geojson, bbox);

                                        rasters[deploy] = rasters_geojson;

                                    }
                                    else
                                        show_alert('{% trans "Não existem imagens de satélite." %}', 5000);
                                } else {
                                    if (bbox.length > 0) map.fitBounds([[bbox[3],bbox[0]],[bbox[1],bbox[2]]], {padding: [50,50]});
                                    show_alert('{% trans "Não foi possível carregar as imagens de satélite." %}', 5000);
                                }
                            },
                            error: function(e, x, r) {
                                if (bbox.length > 0) map.fitBounds([[bbox[3],bbox[0]],[bbox[1],bbox[2]]], {padding: [50,50]});
                                show_alert('{% trans "Não foi possível carregar as imagens de satélite." %}', 5000);
                            }
                        });
                    } 
                    else{
                        var rasters_geojson = rasters[deploy];
                        if(typeof(rasters_geojson) != 'undefined'){
                            if(rasters_geojson.length > 0){
                                $(this).addClass('active');
                                $('#chk_sat' + deploy).attr('checked', 'checked');
                                addSatelliteLayer(rasters_geojson.length, rasters_geojson, bbox);
                            }
                            else
                                show_alert('{% trans "Não existem imagens de satélite." %}', 5000);
                        }
                        else{
                            if (bbox.length > 0) map.fitBounds([[bbox[3],bbox[0]],[bbox[1],bbox[2]]], {padding: [50,50]});
                            show_alert('{% trans "Não foi possível carregar as imagens de satélite." %}', 5000);
                        }
                    }
                }

                else{
                    $(this).removeClass('active');
                    removeSatChecks(deploy);
                    removeSatellites();
                }
            });

            $('button.view-stat').click(function() {
                var deploy = $(this).data('deploy');

                if (!$(this).hasClass('active')) {
                    $(this).addClass('active');
                    // Change icon also
                    var span = $(this).find('span');
                    span.removeClass('glyphicon-eye-open');
                    span.addClass('glyphicon-eye-close');

                    // Add station to map
                    addStationMap(this);

                    // check parent checkbox
                    $('#chk_' + deploy).attr('checked', 'checked');
                } else {
                    $(this).removeClass('active');
                    // Change icon also
                    var span = $(this).find('span');
                    span.removeClass('glyphicon-eye-close');
                    span.addClass('glyphicon-eye-open');

                    // Removes station from map
                    removeStationMap(this);

                    // remove parent checkbox if all removed
                    removeChecks(deploy);
                }
            });

            $('button.tgl-leg').click(function(e) {
                var spanelem = $(this).find('span');
                if (spanelem.hasClass('glyphicon-remove-circle')) {
                    spanelem.removeClass('glyphicon-remove-circle');
                    spanelem.addClass('glyphicon-info-sign');

                    $('#legpanel').css('display', 'none');
                } else {
                    spanelem.removeClass('glyphicon-info-sign');
                    spanelem.addClass('glyphicon-remove-circle');

                    $('#legpanel').css('display', 'block');
                }
            });

            // Set the legend panels sortable
            $('#accordion_legend').sortable({
                axis: 'y',
                stop: function(event, ui) {
                    // on sorting legend rearrange layers z-index on map
                    var i = 0, panelcount = $('#accordion_legend .panel').length + 2;
                    $('#accordion_legend .panel').each(function(){
                        var id_layer = $(this).attr('data-layer');
                        var layer = services[id_layer];
                        //layer.bringToBack(); // TODO - replace to setZIndex
                        layer.setZIndex(panelcount - i);
                        i += 1;
                    });
                }
            });
        });

    </script>
{% endblock content %}
